(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core'], factory) :
	(factory((global['ng4-fittext'] = {}),global.ng.core));
}(this, (function (exports,core) { 'use strict';

var Ng4FittextDirective = /** @class */ (function () {
    /**
     * @param {?} el
     */
    function Ng4FittextDirective(el) {
        var _this = this;
        this.el = el;
        this.fittext = true;
        this.activateOnResize = true;
        this.minFontSize = -1 / 0;
        this.maxFontSize = 1 / 0;
        this.compression = 1;
        this.setFontSize = function () {
            if (_this.fittext) {
                var /** @type {?} */ containerWidth = void 0, /** @type {?} */ fontSize = void 0;
                var /** @type {?} */ windowWidth = window.screen.width;
                var /** @type {?} */ parentWidth = _this.container.parentElement.clientWidth;
                parentWidth > windowWidth ? containerWidth = windowWidth : containerWidth = parentWidth;
                fontSize = Math.max(Math.min(containerWidth / (_this.compression * 10), _this.maxFontSize), _this.minFontSize);
                return _this.el.nativeElement.style.setProperty('font-size', (fontSize).toString() + 'px');
            }
        };
        this.onResize = function () {
            if (_this.activateOnResize) {
                _this.setFontSize();
            }
        };
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    Ng4FittextDirective.prototype.ngOnChanges = function (changes) {
        if (changes['compression'] && !changes['compression'].firstChange) {
            this.setFontSize();
        }
    };
    /**
     * @return {?}
     */
    Ng4FittextDirective.prototype.ngAfterViewInit = function () {
        this.setFontSize();
    };
    return Ng4FittextDirective;
}());
Ng4FittextDirective.decorators = [
    { type: core.Directive, args: [{
                selector: '[fittext]'
            },] },
];
/**
 * @nocollapse
 */
Ng4FittextDirective.ctorParameters = function () { return [
    { type: core.ElementRef, },
]; };
Ng4FittextDirective.propDecorators = {
    'fittext': [{ type: core.Input, args: ['fittext',] },],
    'container': [{ type: core.Input, args: ['container',] },],
    'activateOnResize': [{ type: core.Input, args: ['activateOnResize',] },],
    'minFontSize': [{ type: core.Input, args: ['minFontSize',] },],
    'maxFontSize': [{ type: core.Input, args: ['maxFontSize',] },],
    'compression': [{ type: core.Input, args: ['compression',] },],
    'onResize': [{ type: core.HostListener, args: ['window:resize', ['$event'],] },],
};
var Ng4FittextModule = /** @class */ (function () {
    function Ng4FittextModule() {
    }
    return Ng4FittextModule;
}());
Ng4FittextModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [
                    Ng4FittextDirective
                ],
                exports: [Ng4FittextDirective]
            },] },
];
/**
 * @nocollapse
 */
Ng4FittextModule.ctorParameters = function () { return []; };

exports.Ng4FittextModule = Ng4FittextModule;
exports.ɵa = Ng4FittextDirective;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng4-fittext.umd.js.map
