import { Directive, ElementRef, HostListener, Input, NgModule } from '@angular/core';
var Ng4FittextDirective = /** @class */ (function () {
    /**
     * @param {?} el
     */
    function Ng4FittextDirective(el) {
        var _this = this;
        this.el = el;
        this.fittext = true;
        this.activateOnResize = true;
        this.minFontSize = -1 / 0;
        this.maxFontSize = 1 / 0;
        this.compression = 1;
        this.setFontSize = function () {
            if (_this.fittext) {
                var /** @type {?} */ containerWidth = void 0, /** @type {?} */ fontSize = void 0;
                var /** @type {?} */ windowWidth = window.screen.width;
                var /** @type {?} */ parentWidth = _this.container.parentElement.clientWidth;
                parentWidth > windowWidth ? containerWidth = windowWidth : containerWidth = parentWidth;
                fontSize = Math.max(Math.min(containerWidth / (_this.compression * 10), _this.maxFontSize), _this.minFontSize);
                return _this.el.nativeElement.style.setProperty('font-size', (fontSize).toString() + 'px');
            }
        };
        this.onResize = function () {
            if (_this.activateOnResize) {
                _this.setFontSize();
            }
        };
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    Ng4FittextDirective.prototype.ngOnChanges = function (changes) {
        if (changes['compression'] && !changes['compression'].firstChange) {
            this.setFontSize();
        }
    };
    /**
     * @return {?}
     */
    Ng4FittextDirective.prototype.ngAfterViewInit = function () {
        this.setFontSize();
    };
    return Ng4FittextDirective;
}());
Ng4FittextDirective.decorators = [
    { type: Directive, args: [{
                selector: '[fittext]'
            },] },
];
/**
 * @nocollapse
 */
Ng4FittextDirective.ctorParameters = function () { return [
    { type: ElementRef, },
]; };
Ng4FittextDirective.propDecorators = {
    'fittext': [{ type: Input, args: ['fittext',] },],
    'container': [{ type: Input, args: ['container',] },],
    'activateOnResize': [{ type: Input, args: ['activateOnResize',] },],
    'minFontSize': [{ type: Input, args: ['minFontSize',] },],
    'maxFontSize': [{ type: Input, args: ['maxFontSize',] },],
    'compression': [{ type: Input, args: ['compression',] },],
    'onResize': [{ type: HostListener, args: ['window:resize', ['$event'],] },],
};
var Ng4FittextModule = /** @class */ (function () {
    function Ng4FittextModule() {
    }
    return Ng4FittextModule;
}());
Ng4FittextModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    Ng4FittextDirective
                ],
                exports: [Ng4FittextDirective]
            },] },
];
/**
 * @nocollapse
 */
Ng4FittextModule.ctorParameters = function () { return []; };
/**
 * Generated bundle index. Do not edit.
 */
export { Ng4FittextModule, Ng4FittextDirective as ɵa };
//# sourceMappingURL=ng4-fittext.es5.js.map
